RegionFilter = LibStub ("AceAddon-3.0"):NewAddon ("RegionFilter", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local RegionFilter = RegionFilter

local f = CreateFrame ("frame", nil, UIParent)
f:RegisterEvent ("LFG_LIST_SEARCH_RESULTS_RECEIVED")

function RegionFilter:UpdateList()
	LFGListSearchPanel_UpdateResultList (LFGListFrame.SearchPanel)
	LFGListSearchPanel_UpdateResults (LFGListFrame.SearchPanel)
end

f:SetScript ("OnEvent", function (self, event, ...)
	RegionFilter:ScheduleTimer ("UpdateList", 1)
end)

--> all calls are local
local hooksecurefunc = hooksecurefunc

--> Make a Backup first
function RegionFilter:CreateBackup()
	RegionFilter.original_sort_func = LFGListUtil_SortSearchResultsCB
end

--> Region Realm List
	local na_realms = {
		"Aegwynn",
		"AeriePeak",
		"Agamaggan",
		"Aggramar",
		"Akama",
		"Alextrasza",
		"Alleria",
		"AlterofStorms",
		"AleracMountains",
		"Andorhal",
		"Anetheron",
		"Antonidas",
		"Anub'arak",
		"Anvilmar",
		"Arathor",
		"Archimonde",
		"Area52",
		"ArgentDawn",
		"Arthas",
		"Arygos",
		"Auchindoun",
		"Azgalor",
		"Azjol-Nerub",
		"Azshara",
		"Azuremyst",
		"Baelgun",
		"Balnazzar",
		"BlackDragonflight",
		"Blackhand",
		"Blackrock",
		"BlackwaterRaiders",
		"BlackwingLair",
		"Blade'sEdge",
		"Bladefist",
		"BleedingHollow",
		"BloodFurnace",
		"Bloodhoof",
		"Bloodscalp",
		"Bonechewer",
		"BoreanTundra",
		"Boulderfist",
		"Bronzebeard",
		"BurningBlade",
		"BurningLegion",
		"Caelstrasz",
		"Cairne",
		"CenarionCircle",
		"Cenarius",
		"Cho'gall",
		"Chromaggus",
		"Coilfang",
		"Crushridge",
		"Daggerspine",
		"Dalaran",
		"Dalvenegyr",
		"DarkIron",
		"Darkspear",
		"Darrowmere",
		"Dawnbringer",
		"Deathwing",
		"DemonSoul",
		"Dentarg",
		"Destromath",
		"Dethecus",
		"Detheroc",
		"Doomhammer",
		"Draenor",
		"Dragonblight",
		"Dragonmaw",
		"Drak'Tharon",
		"Drak'Thul",
		"Draka",
		"Drenden",
		"Dunemaul",
		"Durotan",
		"Duskwood",
		"EarthernRing",
		"EchoIsles",
		"Eitrigg",
		"Eldre'Thalas",
		"Elune",
		"EmeraldDream",
		"Eonar",
		"Eredar",
		"Executus",
		"Exodar",
		"Farstriders",
		"Feathermoon",
		"Fenris",
		"Firetree",
		"Fizzcrank",
		"Frostmane",
		"Frostwolf",
		"Galakrond",
		"Garithos",
		"Garona",
		"Garrosh",
		"Ghostlands",
		"Gilneas",
		"Gnomeregan",
		"Gorefiend",
		"Gorgonnash",
		"Greymane",
		"GizzlyHills",
		"Gul'Dawn",
		"Gurubashi",
		"Hakkar",
		"Haomarush",
		"Hellscream",
		"Hydraxis",
		"Hyjal",
		"Icecrown",
		"Illidan",
		"Jaedenar",
		"Kael'Thas",
		"Kalecgos",
		"Kargath",
		"Kel'Thuzad",
		"Khadgar",
		"KhazModan",
		"Kil'jaeden",
		"Kilrogg",
		"KirinTor",
		"Korgath",
		"Korialstrasz",
		"KulTiras",
		"LaughingSkull",
		"Lethon",
		"Lightbringer",
		"Lightning'sBlade",
		"Lightninghoof",
		"Llane",
		"Lothar",
		"Madoran",
		"Maelstrom",
		"Magtheridon",
		"Maiev",
		"Mal'Ganis",
		"Malfurion",
		"Malorne",
		"Malygos",
		"Mannoroth",
		"Medivh",
		"Misha",
		"Mok'Nathal",
		"MoonGuard",
		"Moonrunner",
		"Mug'thol",
		"Muradin",
		"Nathrezim",
		"Nazgrel",
		"Nazjatar",
		"Ner'zhul",
		"Nesingwary",
		"Nordrassil",
		"Norgannon",
		"Onyxia",
		"Perenolde",
		"Proudmoore",
		"Quel'dorei",
		"Ravencrest",
		"Ravenholdt",
		"Rexxar",
		"Rivendare",
		"Runetotem",
		"Sargeras",
		"ScarletCrusade",
		"Scilla",
		"Sen'Jin",
		"Sentinels",
		"ShadowCouncil",
		"Shadowmoon",
		"Shadowsong",
		"Shandris",
		"ShatteredHalls",
		"ShatteredHand",
		"Shu'halo",
		"SilverHand",
		"Silvermoon",
		"SistersofElune",
		"Skullcrusher",
		"Skywall",
		"Smolderthorn",
		"Spinebreaker",
		"Spirestone",
		"Staghelm",
		"SteamwheedleCartel",
		"Stonemaul",
		"Stormrage",
		"Stormreaver",
		"Stormscale",
		"Suramar",
		"Tanaris",
		"Terenas",
		"Terokkar",
		"TheForgottenCoast",
		"TheScryers",
		"TheUnderbog",
		"TheVentureCoast",
		"ThoriumBrotherhood",
		"Thrall",
		"Thunderhorn",
		"Thunderlord",
		"Tichondrius",
		"Tortheldrin",
		"Trollbane",
		"Turalyon",
		"TwistingNether",
		"Uldaman",
		"Uldum",
		"Undermine",
		"Ursin",
		"Uther",
		"Vashj",
		"Vek'nilash",
		"Velen",
		"Warsong",
		"Whisperwind",
		"Wildhammer",
		"Windrunner",
		"Winterhoof",
		"WyrmrestAccord",
		"Ysera",
		"Ysondre",
		"Zangarmarsh",
		"Zul'Jin",
		"Zuluhed"
	}
	local br_realms = {
		"Azralon",
		"Nemesis",
		"Goldrinn",
		"TolBarad",
		"Gallywix"
	}

	local la_realms = {
		"Quel'Thalas",
		"Drakkari",
		"Ragnaros"
	}

	local oc_realms = {
		"Aman'Thul",
		"Barthilas",
		"Caelestrasz",
		"Dath'Remar",
		"Dreadmaul",
		"Frostmourne",
		"Gundrak",
		"Jubei'Thos",
		"Khaz'goroth",
		"Nagrand",
		"Saurfang",
		"Thaurissan",
	}

--> Check the region of each group and highlights if its in your region. This code runs on a region per region basis. See below.
function RegionFilter:InstallHook(realms, label)
	hooksecurefunc ("LFGListSearchEntry_Update", function (self) 
		local id1, activityID1, name1, comment1, voiceChat1, iLvl1, age1, numBNetFriends1, numCharFriends1, numGuildMates1, isDelisted1, _, LN1, numMembers1 = C_LFGList.GetSearchResultInfo (self.resultID)
		
		local name, server = strsplit("-", LN1, 2)
		for _, v in ipairs(realms) do
			if v == server then
				local activityName = C_LFGList.GetActivityInfo (activityID1)
				self.ActivityName:SetText ("|cFFFFFF00["..label.."]|r " .. activityName)
				self.ActivityName:SetTextColor (0, 1, 0)
			end
		end
	end)
end

--> At loadtime
function RegionFilter:OnInitialize()

	RegionFilter:ScheduleTimer ("CreateBackup", 4)
	
	realm = GetRealmName()

	for _, v in ipairs(na_realms) do
		if realm == v then
			RegionFilter:ScheduleTimer ("InstallHook", 5, na_realms, 'NA')
			print("Region Filter: You are an on NA Server")
		end
	end

	for _, v in ipairs(br_realms) do
		if realm == v then
			RegionFilter:ScheduleTimer ("InstallHook", 5, br_realms, 'BR')
			print("Region Filter: You are on a BR server")
		end
	end

	for _, v in ipairs(la_realms) do
		if realm == v then
			RegionFilter:ScheduleTimer ("InstallHook", 5, la_realms, 'LA')
			print("Region Filter: You are on an LA server")
		end
	end

	for _, v in ipairs(oc_realms) do
		if realm == v then
			RegionFilter:ScheduleTimer ("InstallHook", 5, oc_realms, 'OC')
			print("Region FIlter: You are on an OC server")
		end
	end	
end

--> Print to the console some version stuff
local z = CreateFrame("Frame")
z:RegisterEvent("PLAYER_LOGIN")
z:SetScript("OnEvent", function(f, event)
	if event == "PLAYER_LOGIN" then
		print("Region Filter Version 0.4.1 Loaded. If there any bugs please report them via https://wow.curseforge.com/")
	end
end)